Attribute VB_Name = "modIsArraySorted"
Option Explicit

Function IsNumericArraySorted(Arr As Variant) As Boolean
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' IsNumericArraySorted
' This examines the array Arr (which must contain all
' numeric values) and returns True if Arr is in sorted
' order or False if it is not in sorted order.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Dim N As Long
Dim L As Long

If IsArray(Arr) = False Then
    IsNumericArraySorted = False
    Exit Function
End If
If UBound(Arr) - LBound(Arr) + 1 = 1 Then
    ' array has one element.
    IsNumericArraySorted = True
    Exit Function
End If

If Arr(LBound(Arr)) < Arr(LBound(Arr) + 1) Then
    L = 1
ElseIf Arr(LBound(Arr)) = Arr(LBound(Arr) + 1) Then
    L = 0
ElseIf Arr(LBound(Arr)) > Arr(LBound(Arr) + 1) Then
    L = -1
End If

For N = LBound(Arr) To UBound(Arr) - 1
    If Arr(N) < Arr(N + 1) Then
        If L = 0 Then
            L = 1
        ElseIf L = 1 Then
            ' ok
        ElseIf L = -1 Then
            IsNumericArraySorted = False
            Exit Function
        End If
    ElseIf Arr(N) > Arr(N + 1) Then
        If L = 0 Then
            L = -1
        ElseIf L = -1 Then
            ' ok
        ElseIf L = 1 Then
            IsNumericArraySorted = False
            Exit Function
        End If
    End If
Next N
IsNumericArraySorted = True

End Function

Function IsStringArraySorted(Arr As Variant, CompareMethod As VbCompareMethod) As Boolean
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' IsStringArraySorted
' This examines the array Arr (which must contain all
' string values) and returns True if Arr is in sorted
' order or False if it is not in sorted order.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Dim N As Long
Dim L As Long

If IsArray(Arr) = False Then
    IsStringArraySorted = False
    Exit Function
End If
If UBound(Arr) - LBound(Arr) + 1 = 1 Then
    ' array has one element.
    IsStringArraySorted = True
    Exit Function
End If


If StrComp(Arr(LBound(Arr)), Arr(LBound(Arr) + 1), CompareMethod) = -1 Then
    L = -1
ElseIf StrComp(Arr(LBound(Arr)), Arr(LBound(Arr) + 1), CompareMethod) = 0 Then
    L = 0
ElseIf StrComp(Arr(LBound(Arr)), Arr(LBound(Arr) + 1), CompareMethod) = 1 Then
    L = 1
End If

For N = LBound(Arr) To UBound(Arr) - 1
    If StrComp(Arr(N), Arr(N + 1), CompareMethod) = 1 Then
        If L = 0 Then
            L = 1
        ElseIf L = 1 Then
            ' ok
        ElseIf L = -1 Then
            IsStringArraySorted = False
            Exit Function
        End If
    
    ElseIf StrComp(Arr(N), Arr(N + 1), CompareMethod) = -1 Then
        If L = 0 Then
            L = -1
        ElseIf L = -1 Then
            ' ok
        ElseIf L = 1 Then
            IsStringArraySorted = False
            Exit Function
        End If
    End If
Next N
IsStringArraySorted = True

End Function



